import 'package:bloc_logic/common/core/blocs/check/check_bloc.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

class CheckLogic<S, V, F> {
  CheckBloc _checkBloc;
  bool _checked;
  bool _unchecked;

  bool get checked => _checked;
  bool get unchecked => _unchecked;

  CheckBloc get checkBloc => _checkBloc;

  CheckLogic() {
    _checked = false;
    _unchecked = true;
    _checkBloc = CheckBloc();
  }

  void dispose() {
    _checkBloc.close();
  }

  void check() {
    _checked = true;
    _unchecked = false;
    _checkBloc.add(CheckCheckEvent());
  }

  void uncheck() {
    _checked = false;
    _unchecked = true;
    _checkBloc.add(UncheckCheckEvent());
  }

  BlocBuilder builder({
    Function() child,
  }) {
    return BlocBuilder<CheckBloc, CheckState>(
        cubit: _checkBloc,
        builder: (BuildContext context, CheckState checkState) {
          _checked = checkState is CheckedCheckState;
          _unchecked = checkState is UncheckedCheckState;
          return child();
        });
  }
}
