import 'package:bloc_logic/common/core/blocs/radio/radio_bloc.dart';
import 'package:flutter/material.dart';
import 'package:flutter_bloc/flutter_bloc.dart';

class RadioLogic<S, V, F> {
  RadioBloc _radioBloc;

  RadioLogic() {
    _radioBloc = RadioBloc<S, V, F>();
  }

  void select(index) {
    _radioBloc.add(SelectRadioEvent(index));
  }

  void dispose() {
    _radioBloc.close();
  }

  BlocBuilder builder({
    Function(V) selected,
    Function(F) failure,
  }) {
    return BlocBuilder<RadioBloc, RadioState>(
        cubit: _radioBloc,
        builder: (BuildContext context, RadioState radioState) {
          if (radioState is SelectedRadioState) {
            return selected(radioState.index);
          }
          return failure((radioState as FailureRadioState).failure);
        });
  }
}
